#!/bin/sh
###############################################################################
#    Webmin Sysstats - mail.sh
#
#    Webmin Sysstats Module ver 0.4
#    Copyright (C) 2001 by Eric Gerbier
#    Bug reports to: dbouius@users.sourceforge.net or gerbier@users.sourceforge.net
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
###############################################################################


. ../../config
. mailq.cfg

nb_mail_queue () {
	mailq | grep -v "is empty" | wc -l | awk '{print $1}'
}

calcul_gain() {
log=$1

if [ -r $log ]
then
        taille=$(wc -l $log | awk '{print $1}')

        fic_taille_old=${log}.taille

        # first call
        if [ -a ${fic_taille_old} ]
        then
                taille_old=$(cat ${fic_taille_old} )
        else
                taille_old=$taille
        fi

        # backup for next call
        echo $taille > ${fic_taille_old}

        if [ $taille -ge  $taille_old ]
        then
                let gain="$taille - $taille_old"
        else
                gain=-1
        fi
else 
        gain=-1
fi

echo $gain
}

if [ -z "$mailq" ]
then
    exit
else
    nb_mailq=$(nb_mail_queue)
   
	taille=$(calcul_gain /var/log/maillog)

	if [ $taille -eq -1 ]
	then
		nb_sendmail=U
		nb_pop=U
		nb_imap=U
	else
		nb_sendmail=$(tail -$taille /var/log/maillog | grep sendmail | wc -l | awk '{print $1}')
		nb_pop=$(tail -$taille /var/log/maillog | grep ipop3d | grep Login | wc -l | awk '{print $1}')
		nb_imap=$(tail -$taille /var/log/maillog | grep imapd | grep Login | wc -l | awk '{print $1}')
	fi

	$rrdtool update ${rrdtables}mailq.rrd N:${nb_mailq}:${nb_sendmail}:${nb_pop}:${nb_imap}
fi
